#include "MeshLoaders/MeshLoader.h"


void MeshLoader::PrintMesh() {

}

std::vector<Node>& MeshLoader::GetNodes() {
    return nodes;
}

std::vector<FiniteElement>& MeshLoader::GetFiniteElements() {
    return finiteElements;
}

std::vector<BoundaryFiniteElement>& MeshLoader::GetBoundaryFiniteElements() {
    return boundaryFiniteElements;
}

std::vector<FiniteElement> MeshLoader::GetFiniteElementsByNodesId(size_t id1, size_t id2, size_t id3) {
    std::vector<FiniteElement> result;
    auto resultIter = finiteElements.begin();
    auto resultEndIter = finiteElements.end();
    while (resultIter != resultEndIter) {
        resultIter = std::find_if(resultIter, resultEndIter, [id1, id2, id3] (FiniteElement currentElement) {
            auto iterBegin = currentElement.nodesId.begin();
            auto iterEnd = currentElement.nodesId.end();
            return  std::find(iterBegin, iterEnd, id1) != iterEnd &&
                    std::find(iterBegin, iterEnd, id2) != iterEnd &&
                    std::find(iterBegin, iterEnd, id3) != iterEnd;
        });

        if (resultIter != resultEndIter) {
            result.push_back(*resultIter);
            ++resultIter;
        }
    }

    return result;
}

std::vector<FiniteElement> MeshLoader::GetFiniteElementsByEdge(size_t firstVerticeId, size_t secondVerticeId) {
    std::vector<FiniteElement> result;
    auto resultIter = finiteElements.begin();
    auto resultEndIter = finiteElements.end();
    while (resultIter != resultEndIter) {
        resultIter = std::find_if(resultIter, resultEndIter, [firstVerticeId, secondVerticeId] (FiniteElement currentElement) {
            auto iterBegin = currentElement.nodesId.begin();
            auto iterEnd = currentElement.nodesId.end();
            return  std::find(iterBegin, iterEnd, secondVerticeId) != iterEnd &&
                    std::find(iterBegin, iterEnd, firstVerticeId) != iterEnd;
        });

        if (resultIter != resultEndIter) {
            result.push_back(*resultIter);
            ++resultIter;
        }
    }

    return result;
}

std::vector<Node> MeshLoader::GetVertexNodesBySurfaceId(size_t surfaceId) {
    return {};
}
